                                                                                                                                                                                                                                                               
Delivered-To: blauwirbel@gmail.com
Received: by 10.143.166.2 with SMTP id t2cs69989wfo;
        Thu, 28 Aug 2008 10:20:26 -0700 (PDT)
Received: by 10.151.102.16 with SMTP id e16mr2511173ybm.153.1219944026430;
        Thu, 28 Aug 2008 10:20:26 -0700 (PDT)
Return-Path: <qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org>
Received: from lists.gnu.org (lists.gnu.org [199.232.76.165])
        by mx.google.com with ESMTP id n29si1419023elf.5.2008.08.28.10.20.25;
        Thu, 28 Aug 2008 10:20:26 -0700 (PDT)
Received-SPF: pass (google.com: domain of qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org designates 199.232.76.165 as permitted sender) client-ip=199.232.76.165;
Authentication-Results: mx.google.com; spf=pass (google.com: domain of qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org designates 199.232.76.165 as permitted sender) smtp.mail=qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org
Received: from localhost ([127.0.0.1]:56948 helo=lists.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43)
	id 1KYkqH-0001t0-Nr
	for blauwirbel@gmail.com; Thu, 28 Aug 2008 12:59:29 -0400
Received: from mailman by lists.gnu.org with tmda-scanned (Exim 4.43)
	id 1KYkjp-00005R-Me
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:49 -0400
Received: from exim by lists.gnu.org with spam-scanned (Exim 4.43)
	id 1KYkjp-0008W1-2h
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:49 -0400
Received: from [199.232.76.173] (port=36288 helo=monty-python.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43) id 1KYkjo-0008Vc-QB
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:48 -0400
Received: from il.qumranet.com ([212.179.150.194]:48333)
	by monty-python.gnu.org with esmtp (Exim 4.60)
	(envelope-from <gleb@qumranet.com>) id 1KYkjo-0004m4-ME
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:48 -0400
Received: from gleb-debian.qumranet.com (gleb-debian.qumranet.com.qumranet.com
	[172.16.15.143])
	by il.qumranet.com (Postfix) with ESMTP id 89783250DB2
	for <qemu-devel@nongnu.org>; Thu, 28 Aug 2008 19:52:47 +0300 (IDT)
Received: from gleb-debian.qumranet.com.qumranet.com (localhost [127.0.0.1])
	by gleb-debian.qumranet.com (Postfix) with ESMTP id 88CBA18D48F
	for <qemu-devel@nongnu.org>; Thu, 28 Aug 2008 19:52:47 +0300 (IDT)
From: Gleb Natapov <gleb@qumranet.com>
To: qemu-devel@nongnu.org
Date: Thu, 28 Aug 2008 19:52:47 +0300
Message-ID: <20080828165247.22851.73230.stgit@gleb-debian.qumranet.com.qumranet.com>
In-Reply-To: <20080828165232.22851.77678.stgit@gleb-debian.qumranet.com.qumranet.com>
References: <20080828165232.22851.77678.stgit@gleb-debian.qumranet.com.qumranet.com>
User-Agent: StGIT/0.14.2
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 7bit
X-detected-kernel: by monty-python.gnu.org: Linux 2.6 (newer, 1)
Subject: [Qemu-devel] [PATCH v3 3/6] Add "info uuid" command to monitor.
X-BeenThere: qemu-devel@nongnu.org
X-Mailman-Version: 2.1.5
Precedence: list
Reply-To: qemu-devel@nongnu.org
List-Id: qemu-devel.nongnu.org
List-Unsubscribe: <http://lists.nongnu.org/mailman/listinfo/qemu-devel>,
	<mailto:qemu-devel-request@nongnu.org?subject=unsubscribe>
List-Archive: <http://lists.gnu.org/pipermail/qemu-devel>
List-Post: <mailto:qemu-devel@nongnu.org>
List-Help: <mailto:qemu-devel-request@nongnu.org?subject=help>
List-Subscribe: <http://lists.nongnu.org/mailman/listinfo/qemu-devel>,
	<mailto:qemu-devel-request@nongnu.org?subject=subscribe>
Sender: qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org
Errors-To: qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org

Signed-off-by: Gleb Natapov <gleb@qumranet.com>
---

 monitor.c |   11 +++++++++++
 1 files changed, 11 insertions(+), 0 deletions(-)

Index: qemu/monitor.c
===================================================================
--- qemu.orig/monitor.c	2008-08-31 12:34:21.000000000 +0000
+++ qemu/monitor.c	2008-08-31 12:35:33.000000000 +0000
@@ -253,6 +253,15 @@
         term_printf("%s\n", qemu_name);
 }
 
+static void do_info_uuid(void)
+{
+    term_printf(UUID_FMT "\n", qemu_uuid[0], qemu_uuid[1], qemu_uuid[2],
+            qemu_uuid[3], qemu_uuid[4], qemu_uuid[5], qemu_uuid[6],
+            qemu_uuid[7], qemu_uuid[8], qemu_uuid[9], qemu_uuid[10],
+            qemu_uuid[11], qemu_uuid[12], qemu_uuid[13], qemu_uuid[14],
+            qemu_uuid[15]);
+}
+
 static void do_info_block(void)
 {
     bdrv_info();
@@ -1501,6 +1510,8 @@
       "", "show the vnc server status"},
     { "name", "", do_info_name,
       "", "show the current VM name" },
+    { "uuid", "", do_info_uuid,
+      "", "show the current VM UUID" },
 #if defined(TARGET_PPC)
     { "cpustats", "", do_info_cpu_stats,
       "", "show CPU statistics", },