                                                                                                                                                                                                                                                               
Delivered-To: blauwirbel@gmail.com
Received: by 10.143.166.2 with SMTP id t2cs69204wfo;
        Thu, 28 Aug 2008 10:08:57 -0700 (PDT)
Received: by 10.187.249.5 with SMTP id b5mr1220432fas.71.1219943335973;
        Thu, 28 Aug 2008 10:08:55 -0700 (PDT)
Return-Path: <qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org>
Received: from lists.gnu.org (lists.gnu.org [199.232.76.165])
        by mx.google.com with ESMTP id h6si6689353nfh.21.2008.08.28.10.08.54;
        Thu, 28 Aug 2008 10:08:55 -0700 (PDT)
Received-SPF: pass (google.com: domain of qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org designates 199.232.76.165 as permitted sender) client-ip=199.232.76.165;
Authentication-Results: mx.google.com; spf=pass (google.com: domain of qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org designates 199.232.76.165 as permitted sender) smtp.mail=qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org
Received: from localhost ([127.0.0.1]:58362 helo=lists.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43)
	id 1KYkte-0002mI-4j
	for blauwirbel@gmail.com; Thu, 28 Aug 2008 13:02:58 -0400
Received: from mailman by lists.gnu.org with tmda-scanned (Exim 4.43)
	id 1KYkk0-0000IU-29
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:53:00 -0400
Received: from exim by lists.gnu.org with spam-scanned (Exim 4.43)
	id 1KYkjz-0000H3-Cy
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:59 -0400
Received: from [199.232.76.173] (port=36292 helo=monty-python.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43) id 1KYkjz-0000Gl-49
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:59 -0400
Received: from il.qumranet.com ([212.179.150.194]:48340)
	by monty-python.gnu.org with esmtp (Exim 4.60)
	(envelope-from <gleb@qumranet.com>) id 1KYkjy-0004qK-Sc
	for qemu-devel@nongnu.org; Thu, 28 Aug 2008 12:52:59 -0400
Received: from gleb-debian.qumranet.com (gleb-debian.qumranet.com.qumranet.com
	[172.16.15.143])
	by il.qumranet.com (Postfix) with ESMTP id AE2AA250DB2
	for <qemu-devel@nongnu.org>; Thu, 28 Aug 2008 19:52:57 +0300 (IDT)
Received: from gleb-debian.qumranet.com.qumranet.com (localhost [127.0.0.1])
	by gleb-debian.qumranet.com (Postfix) with ESMTP id AD78F18D48F
	for <qemu-devel@nongnu.org>; Thu, 28 Aug 2008 19:52:57 +0300 (IDT)
From: Gleb Natapov <gleb@qumranet.com>
To: qemu-devel@nongnu.org
Date: Thu, 28 Aug 2008 19:52:57 +0300
Message-ID: <20080828165257.22851.2530.stgit@gleb-debian.qumranet.com.qumranet.com>
In-Reply-To: <20080828165232.22851.77678.stgit@gleb-debian.qumranet.com.qumranet.com>
References: <20080828165232.22851.77678.stgit@gleb-debian.qumranet.com.qumranet.com>
User-Agent: StGIT/0.14.2
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 7bit
X-detected-kernel: by monty-python.gnu.org: Linux 2.6 (newer, 1)
Subject: [Qemu-devel] [PATCH v3 5/6] Add UUID to firmware configuration info.
X-BeenThere: qemu-devel@nongnu.org
X-Mailman-Version: 2.1.5
Precedence: list
Reply-To: qemu-devel@nongnu.org
List-Id: qemu-devel.nongnu.org
List-Unsubscribe: <http://lists.nongnu.org/mailman/listinfo/qemu-devel>,
	<mailto:qemu-devel-request@nongnu.org?subject=unsubscribe>
List-Archive: <http://lists.gnu.org/pipermail/qemu-devel>
List-Post: <mailto:qemu-devel@nongnu.org>
List-Help: <mailto:qemu-devel-request@nongnu.org?subject=help>
List-Subscribe: <http://lists.nongnu.org/mailman/listinfo/qemu-devel>,
	<mailto:qemu-devel-request@nongnu.org?subject=subscribe>
Sender: qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org
Errors-To: qemu-devel-bounces+blauwirbel=gmail.com@nongnu.org

Signed-off-by: Gleb Natapov <gleb@qumranet.com>
---

 hw/fw_cfg.c |    2 ++
 hw/fw_cfg.h |    1 +
 2 files changed, 3 insertions(+), 0 deletions(-)

Index: qemu/hw/fw_cfg.c
===================================================================
--- qemu.orig/hw/fw_cfg.c	2008-08-31 12:35:26.000000000 +0000
+++ qemu/hw/fw_cfg.c	2008-08-31 12:35:40.000000000 +0000
@@ -22,6 +22,7 @@
  * THE SOFTWARE.
  */
 #include "hw.h"
+#include "sysemu.h"
 #include "isa.h"
 #include "fw_cfg.h"
 
@@ -212,6 +213,7 @@
 
     }
     fw_cfg_add_bytes(s, FW_CFG_SIGNATURE, (uint8_t *)"QEMU", 4);
+    fw_cfg_add_bytes(s, FW_CFG_UUID, qemu_uuid, 16);
     register_savevm("fw_cfg", -1, 1, fw_cfg_save, fw_cfg_load, s);
     qemu_register_reset(fw_cfg_reset, s);
     fw_cfg_reset(s);
Index: qemu/hw/fw_cfg.h
===================================================================
--- qemu.orig/hw/fw_cfg.h	2008-08-31 12:35:26.000000000 +0000
+++ qemu/hw/fw_cfg.h	2008-08-31 12:35:40.000000000 +0000
@@ -3,6 +3,7 @@
 
 #define FW_CFG_SIGNATURE        0x00
 #define FW_CFG_ID               0x01
+#define FW_CFG_UUID             0x02
 #define FW_CFG_MAX_ENTRY        0x10
 
 #define FW_CFG_ARCH_LOCAL       0x8000